/**
 * \file
 *
 * \brief USBuײ(UDD)pAPI
 *
 * 쌠 (c) 2009 - 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDD_H_
#define _UDD_H_

#include "usb_protocol.h"
#include "udc_desc.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup usb_device_group
 * \defgroup udd_group USBuײ(UDD)
 *
 * UDDײނ͑uʰ޳̒ʒۉ񋟂܂Bwǂ̎ۂUDCUDI
 * ĂԂƂUDDɂ邩Ȃ荞݂̂悤ʰ޳ė܂B
 *
 * @{
 */

//! \brief ߲Ďʎq
typedef uint8_t udd_ep_id_t;

//! \brief ߲ē]
//! udd_ep_runٰ݌oRŌĂі߂ڼ޽ҰŕԂ܂B
typedef enum {
	UDD_EP_TRANSFER_OK = 0,
	UDD_EP_TRANSFER_ABORT = 1,
} udd_ep_status_t;

/**
 * \brief SETUPvǗ̏^ċL^邽߂̑S̕ϐ
 *
 * ̑S̕ϐSETUPv𕜍ĉ邱Ƃ܂BUDC
 * udc_process_setup()܂UDI*setup()ɂčXV꓾܂B
 */
typedef struct {
	//! USB SETUP߹ĂŎ󂯎ް
	//! :uin16_tle16_tւ"req.wValues"̌UDDɂčs܂B
	usb_setup_req_t req;

	//! 㑱SETUP߹Ăްő܂͖邽߂̊ɏՕւ̈ʒuwq
	uint8_t *payload;

	//! ܂͖ɏՕ̑傫A]e޲Đ
	uint16_t payload_size;

	//! SETUPvZLP󂯎ɌĂ΂Ăі߂
	void (*callback) (void);

	//! ^ꂽɏՕ(.payload)t܂͋̎ɌĂ΂Ăі߂
	//! ް]~ɑ΂falseA.payload.ł̐VɏՕtrueԂ܂B
	bool(*over_under_run) (void);
} udd_ctrl_request_t;
extern udd_ctrl_request_t udd_g_ctrlreq;

//! \a udd_g_ctrlreq SETUPvINް]ꍇtrueԂ܂B
#define  Udd_setup_is_in()       \
      (USB_REQ_DIR_IN == (udd_g_ctrlreq.req.bmRequestType & USB_REQ_DIR_MASK))

//! \a udd_g_ctrlreq SETUPvOUTް]ꍇtrueԂ܂B
#define  Udd_setup_is_out()      \
      (USB_REQ_DIR_OUT == (udd_g_ctrlreq.req.bmRequestType & USB_REQ_DIR_MASK))

//! \a udd_g_ctrlreq SETUPv̌^Ԃ܂B\see usb_reqtype
#define  Udd_setup_type()        \
      (udd_g_ctrlreq.req.bmRequestType & USB_REQ_TYPE_MASK)

//! \a udd_g_ctrlreq SETUPv̎M҂Ԃ܂B\see usb_recipient
#define  Udd_setup_recipient()   \
      (udd_g_ctrlreq.req.bmRequestType & USB_REQ_RECIP_MASK)

/**
 * \brief udd_ep_wait_stall_clear()ٰ݂ɂĂ~IĂі߂֐^
 * ߲Ē~鎞ɌĂ΂Ăі߂
 */
typedef void (*udd_callback_halt_cleared_t) (void);

/**
 * \brief udd_ep_run()ٰ݂ɂēo^]IĂі߂֐^
 * ް]܂͒~(ؾā`)USB荞݂ɂČĂ΂Ăі߂
 *
 * \param  status ]ꍇUDD_EP_TRANSFER_OK
 * \param  status ]~ꂽꍇUDD_EP_TRANSFER_ABORT
 * \param  n      ]ꂽް
 */
typedef void (*udd_callback_trans_t) (udd_ep_status_t status,
		iram_size_t nb_transfered, udd_ep_id_t ep);

/**
 * \brief VBUSۂF
 *
 * \return VBUSĎ\Ȃtrue
 */
bool udd_include_vbus_monitoring(void);

/**
 * \brief USBu
 */
void udd_enable(void);

/**
 * \brief USBu֎~
 */
void udd_disable(void);

/**
 * \brief \Ȏɑu޽Ɏt
 *
 * \warning ײނVBUS䂪܂܂ꍇAνĂ̎󂯓\VBUSق
 *          oꂽɑut܂B
 */
void udd_attach(void);

/**
 * \brief ޽瑕uO
 *
 * ײD-D+USBٱ߂폜Ȃ΂Ȃ܂B
 */
void udd_detach(void);

/**
 * \brief USBu킪ősĂ邩ۂ
 *
 * \return uősĂꍇ\c true AȂ\c false
 */
bool udd_is_high_speed(void);

/**
 * \brief USBu̱ڽύX
 *
 * \param  address VUSBڽ
 */
void udd_set_address(uint8_t address);

/**
 * \brief USBu̱ڽԂB
 *
 * \return USBڽ
 */
uint8_t udd_getaddress(void);

/**
 * \brief ݂ڰъJnԍԂB
 *
 * \return ݂ڰъJnԍ
 */
uint16_t udd_get_frame_number(void);

/**
 * \brief ݂ϲ ڰъJnԍԂB
 *
 * \return ŕKvƂ錻݂ϲ ڰъJnԍ
 */
uint16_t udd_get_micro_frame_number(void);

/*! \brief USBײނ͏ĊJĂяoĊJM𑗏o
 */
void udd_send_remotewakeup(void);

/**
 * \brief \ݒ{̂ݒ
 *
 * \param  payload      {̂̈ʒuwq
 * \param  payload_size {̂̑傫
 */
void udd_set_setup_payload( uint8_t *payload, uint16_t payload_size );


/**
 * \name ߲ĊǗ
 *
 * ȉ̊֐ʹ߲Ă̍쐬ƍ폜łȂݒAAƂ"~"
 * "荞"̏Ԗ₢킹ײނɋ܂B
 */
//@{

#if (USB_DEVICE_MAX_EP != 0)

/**
 * \brief ߲Ă\ݒ肵ċ
 *
 * \param  ep              (USB_EP_DIR_IN/USB_EP_DIR_OUT܂޴߲Ĕԍ
 * \param  bmAttributes    LqqŐ錾ꂽ߲Ă̑
 * \param  MaxEndpointSize ߲Ă̍ő̑傫
 *
 * \return ߲ĂȂ\c 1 AȂ\c 0
 */
bool udd_ep_alloc(udd_ep_id_t ep, uint8_t bmAttributes,
		uint16_t MaxEndpointSize);

/**
 * \brief ߲Ă֎~
 *
 * \param  ep (USB_EP_DIR_IN/USB_EP_DIR_OUT)܂޴߲Ĕԍ
 */
void udd_ep_free(udd_ep_id_t ep);

/**
 * \brief \a ep ̴߲Ă~Ă邩
 *
 * \param  ep ׂ߲Ă̎ʎq
 *
 * \return \a ep ~Ȃ\c 1 AȂ\c 0
 */
bool udd_ep_is_halted(udd_ep_id_t ep);

/**
 * \brief \a ep ̴߲Ă̒~Ԃݒ
 *
 * ̊֐ĂяoA\a ep ł̂ǂ̒PʏSTALL޼oɏI܂B
 * ǂAǂۗ̕PʏŏɎs܂B
 *
 * \param  ep ~߲Ă̎ʎq
 *
 * \return \a ep ~\c 1 AȂ\c 0
 */
bool udd_ep_set_halt(udd_ep_id_t ep);

/**
 * \brief \a ep ̴߲Ă̒~Ԃ
 *
 * ̊֐ĂяoA\a ep ł̂ǂ̒PʏʂɏAASTALL
 * ͑ꂸAݐ؂ւDATA0Ŏn܂܂B
 *
 * \param  ep ~߲Ă̎ʎq
 *
 * \return ֐ɏI\c 1 AȂ\c 0
 */
bool udd_ep_clear_halt(udd_ep_id_t ep);

/**
 * \brief ߲Ē~鎞ɌĂ΂邽߂ɌĂі߂o^
 *
 * \param  ep       gp߲Ă̎ʎq
 * \param  callback NULL܂ʹ߲Ē~ɌĂ΂֐
 *
 * \warning ߲Ă~łȂ΁A\a callback Ă΂܂B
 *
 * \return o^󂯓ꂽȂ\c 1 AȂ\c 0
 */
bool udd_ep_wait_stall_clear(udd_ep_id_t ep,
		udd_callback_halt_cleared_t callback);

/**
 * \brief ߲Ăް̎M܂͑MB
 *
 * ײނ͂ꂪp\Ȃ΁ASRAM߲Ăް]̂ɓ
 * DMA USBgp܂B]I܂͒~(~AؾāA`)鎞ɁA
 * \a callback ̌Ăі߂Ă΂܂B\a callback ̌Ăі߂͓]Ԃƌǂ
 * ]޲ĐԂ܂B
 * :߲Ă͔F܂B
 *
 * \param  ep            gp߲Ă̎ʎq
 * \param  b_shortpacket Z߹ċ
 * \param  buf           ܂͖RAM̊ɏՕB͐łȂ
 *                       Ȃ炸ACOMPILER_WORD_ALIGNEDgpĂB
 * \param  buf_size      ܂͖ɏՕ̑傫
 * \param  callback      NULL܂͓]̏IŌĂԊ֐
 *
 * \warning \a b_shortpacketɂāAIN߲ĂɊւĒZ߹(܂0߹)
 *          ް]̍ŌUSB]𐳂邽߂USBɑ邱Ƃ
 *          ܂B(ٸ)Ɗ荞݂OUT߲ĂɊւް]̍Ō
 *          (Z߹Ă̎󂯎)œ]Iɒ~܂B
 *
 * \return ɏI1 AȂ\c 0
 */
bool udd_ep_run(udd_ep_id_t ep, bool b_shortpacket,
		uint8_t * buf, iram_size_t buf_size,
		udd_callback_trans_t callback);
/**
 * \brief ߲ĂŐis̓]𒆎~
 *
 * ]is̏ꍇA͒~ē]̍Ō}邽߂ɓo^ꂽĂ
 * ߂Ă΂܂B
 * :߲Ă͔F܂B
 *
 * \param  ep ~߲
 */
void udd_ep_abort(udd_ep_id_t ep);

#endif

//@}


/**
 * \name Ǘ
 *
 * ȉ̊֐͍ŕKvƂ茟֔ԂƂ𑕒uɋ܂B
 */
//@{
void udd_test_mode_j(void);
void udd_test_mode_k(void);
void udd_test_mode_se0_nak(void);
void udd_test_mode_packet(void);
//@}


/**
 * \name UDDɑ΂Ē񋟂UDCĂі߂
 *
 * The ȉ̌Ăі߂UDDɂĎgp܂B
 */
//@{

/**
 * \brief SETUPv̕ƊǗ
 *
 * SETUP߹ĂMꂽײނ͂Ăт܂B\c udd_g_ctrlreq SETUP
 * Ăް܂݂܂B̌Ăі߂SETUPv󂯓ȂA\c 1 Ԃ
 * ΂Ȃ炸Aǂް̑M܂͎M̂߂\c udd_g_ctrlreq XV
 * B
 *
 * \return v󂯂ꂽȂ\c 1 AȂ\c 0
 */
extern bool udc_process_setup(void);

/**
 * \brief UDCؾ
 *
 * UDC͑SĂ̌`ԐݒؾĂȂ΂Ȃ܂B
 */
extern void udc_reset(void);

/**
 * \brief SOF}
 *
 * UDC͑SĂ̋ꂽSĂUDIɍ}Ȃ΂Ȃ܂B
 */
extern void udc_sof_notify(void);

//@}

//@}

#ifdef __cplusplus
}
#endif
#endif // _UDD_H_
