/**
 * \file
 *
 * \brief USBK`
 *
 * ̧قUSB 2.0dlɂĒ񋟂USB`ް\̂܂݂܂B
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _USB_PROTOCOL_H_
#define _USB_PROTOCOL_H_

#include "usb_atmel.h"

/**
 * \ingroup usb_group
 * \defgroup usb_protocol_group USBK`
 *
 * ̒PʕUSB 2.0dlɂĒ񋟂萔ް\̂`܂B
 *
 * @{
 */

//! bcdUSB̈pl
#define  USB_V2_0					0x0200	//!< USBdl2.00

/*! \name Sʒ`(׽A׽AK)
 */
//! @{
#define  NO_CLASS					0x00
#define  CLASS_VENDOR_SPECIFIC		0xFF
#define  NO_SUBCLASS				0x00
#define  NO_PROTOCOL				0x00
//! @}

//! \name ̪gLqq(IAD:Interface Association Descriptor)萔
//! @{
#define  CLASS_IAD					0xEF
#define  SUB_CLASS_IAD				0x02
#define  PROTOCOL_IAD				0x01
//! @}

/**
 * \brief USBvް](bmRequestType)
 */
#define  USB_REQ_DIR_OUT			(0<<7)	//!< νĂ瑕u
#define  USB_REQ_DIR_IN				(1<<7)	//!< uνĂ
#define  USB_REQ_DIR_MASK			(1<<7)	//!< Օ

/**
 * \brief USBv^(bmRequestType)
 */
#define  USB_REQ_TYPE_STANDARD		(0<<5)	//!< Wv
#define  USB_REQ_TYPE_CLASS			(1<<5)	//!< ׽v
#define  USB_REQ_TYPE_VENDOR		(2<<5)	//!< ғv
#define  USB_REQ_TYPE_MASK			(3<<5)	//!< Օ

/**
 * \brief USBMҕ(bmRequestType)
 */
#define  USB_REQ_RECIP_DEVICE		(0<<0)	//!< M҂͑u
#define  USB_REQ_RECIP_INTERFACE	(1<<0)	//!< M҂Ͳ̪
#define  USB_REQ_RECIP_ENDPOINT		(2<<0)	//!< MҴ߲
#define  USB_REQ_RECIP_OTHER		(3<<0)	//!< M҂͂̑
#define  USB_REQ_RECIP_MASK			(0x1F)	//!< Օ

/**
 * \brief WUSBv(bRequest)
 */
enum usb_reqid {
	USB_REQ_GET_STATUS			=  0,
	USB_REQ_CLEAR_FEATURE		=  1,
	USB_REQ_SET_FEATURE			=  3,
	USB_REQ_SET_ADDRESS			=  5,
	USB_REQ_GET_DESCRIPTOR		=  6,
	USB_REQ_SET_DESCRIPTOR		=  7,
	USB_REQ_GET_CONFIGURATION	=  8,
	USB_REQ_SET_CONFIGURATION	=  9,
	USB_REQ_GET_INTERFACE		= 10,
	USB_REQ_SET_INTERFACE		= 11,
	USB_REQ_SYNCH_FRAME			= 12,
};

/**
 * \brief WUSBu׸
 *
 */
enum usb_device_status {
	USB_DEV_STATUS_BUS_POWERED	= 0,
	USB_DEV_STATUS_SELF_POWERED	= 1,
	USB_DEV_STATUS_REMOTEWAKEUP	= 2
};

/**
 * \brief WUSB̪׸
 *
 */
enum usb_interface_status {
	USB_IFACE_STATUS_RESERVED	= 0
};

/**
 * \brief WUSB߲ď׸
 *
 */
enum usb_endpoint_status {
	USB_EP_STATUS_HALTED		= 1,
};

/**
 * \brief WUSBu@\׸
 *
 * \note SetFeaturevɑ΂ėL
 */
enum usb_device_feature {
	USB_DEV_FEATURE_REMOTE_WAKEUP			= 1,	//!< uNオ苖
	USB_DEV_FEATURE_TEST_MODE				= 2,		//!< USB
	USB_DEV_FEATURE_OTG_B_HNP_ENABLE		= 3,
	USB_DEV_FEATURE_OTG_A_HNP_SUPPORT		= 4,
	USB_DEV_FEATURE_OTG_A_ALT_HNP_SUPPORT	= 5
};

/**
 * \brief HS USBuŉ\Ȍ
 *
 * \note USB_DEV_FEATURE_TEST_MODEvɑ΂ėL
 */
enum usb_device_hs_test_mode {
	USB_DEV_TEST_MODE_J				= 1,
	USB_DEV_TEST_MODE_K				= 2,
	USB_DEV_TEST_MODE_SE0_NAK		= 3,
	USB_DEV_TEST_MODE_PACKET		= 4,
	USB_DEV_TEST_MODE_FORCE_ENABLE	= 5,
};

/**
 * \brief WUSB߲ċ@\/׸
 */
enum usb_endpoint_feature {
	USB_EP_FEATURE_HALT				= 0,
};

/**
 * \brief WUSBI
 */
enum usb_test_mode_selector {
	USB_TEST_J						= 0x01,
	USB_TEST_K						= 0x02,
	USB_TEST_SE0_NAK				= 0x03,
	USB_TEST_PACKET					= 0x04,
	USB_TEST_FORCE_ENABLE			= 0x05,
};

/**
 * \brief WUSBLqq^
 */
enum usb_descriptor_type {
	USB_DT_DEVICE						= 1,
	USB_DT_CONFIGURATION				= 2,
	USB_DT_STRING						= 3,
	USB_DT_INTERFACE					= 4,
	USB_DT_ENDPOINT						= 5,
	USB_DT_DEVICE_QUALIFIER				= 6,
	USB_DT_OTHER_SPEED_CONFIGURATION	= 7,
	USB_DT_INTERFACE_POWER				= 8,
	USB_DT_OTG							= 9,
	USB_DT_IAD							= 0x0B,
};

/**
 * \brief WUSB߲ē]`
 */
enum usb_ep_type {
	USB_EP_TYPE_CONTROL			= 0x00,
	USB_EP_TYPE_ISOCHRONOUS		= 0x01,
	USB_EP_TYPE_BULK			= 0x02,
	USB_EP_TYPE_INTERRUPT		= 0x03,
	USB_EP_TYPE_MASK			= 0x03,
};

/**
 * \brief LqqpWUSBꎯʎq
 */
enum usb_langid {
	USB_LANGID_EN_US			= 0x0409,	//!< p(č)
};

/**
 * \brief ߲ ڽ̎wWIՕ
 */
#define  USB_EP_ADDR_MASK		0x0f

//! \brief USBڽʎq
typedef uint8_t usb_add_t;

/**
 * \brief ߲ē]IN
 */
#define  USB_EP_DIR_IN			0x80

/**
 * \brief ߲ē]OUT
 */
#define  USB_EP_DIR_OUT			0x00

//! \brief ߲Ďʎq
typedef uint8_t usb_ep_t;

/**
 * \brief USBLqq޲Ăł̍ő咷
 *
 * USBLqq̍ő咷8ޯĂbLengtḧɂĐ܂B
 */
#define  USB_MAX_DESC_LEN		255

/*
 * SĂUSB\̂ɂ2޲Đ񂪋߂܂B
 */
COMPILER_PACK_SET(1)

/**
 * \brief USBuSETUPv
 *
 * SETUP߹Ăް{̂͏Ɉȉ̍\̂ɏ]܂B
 */
typedef struct {
	uint8_t bmRequestType;
	uint8_t bRequest;
	le16_t wValue;
	le16_t wIndex;
	le16_t wLength;
} usb_setup_req_t;

/**
 * \brief WUSBuLqq\
 */
typedef struct {
	uint8_t bLength;
	uint8_t bDescriptorType;
	le16_t bcdUSB;
	uint8_t bDeviceClass;
	uint8_t bDeviceSubClass;
	uint8_t bDeviceProtocol;
	uint8_t bMaxPacketSize0;
	le16_t idVendor;
	le16_t idProduct;
	le16_t bcdDevice;
	uint8_t iManufacturer;
	uint8_t iProduct;
	uint8_t iSerialNumber;
	uint8_t bNumConfigurations;
} usb_dev_desc_t;

/**
 * \brief WUSBuCqLqq\
 *
 * ̋Lqq""xős鎞̑uɂĂ̏܂݂܂(Au
 * ݍœĂȂA̋Lqq͑uSœĂꍇɕς
 * ̂߂̂Ɏgp邱Ƃł܂)B
 */
typedef struct {
	uint8_t bLength;
	uint8_t bDescriptorType;
	le16_t bcdUSB;
	uint8_t bDeviceClass;
	uint8_t bDeviceSubClass;
	uint8_t bDeviceProtocol;
	uint8_t bMaxPacketSize0;
	uint8_t bNumConfigurations;
	uint8_t bReserved;
} usb_dev_qual_desc_t;


/**
 * \brief WUSB̪AgLqq\
 */
typedef struct {
	uint8_t bLength;			//!< ̋Lqq޲Ăł̑傫
	uint8_t bDescriptorType;	//!< ̪Lqq^
	uint8_t bFirstInterface;	//!< ̪
	uint8_t bInterfaceCount;	//!< ֐ݒIԂ߂̒l
	uint8_t bFunctionClass;		//!< USBɂĊ蓖Ă׽
	uint8_t bFunctionSubClass;	//!< USBɂĊ蓖Ă镛׽
	uint8_t bFunctionProtocol;	//!< USBɂĊ蓖ĂK񕄍
	uint8_t iFunction;			//!< Lqq̎wW
} usb_association_desc_t;


/**
 * \brief WUSB`ԐݒLqq\
 */
typedef struct {
	uint8_t bLength;
	uint8_t bDescriptorType;
	le16_t wTotalLength;
	uint8_t bNumInterfaces;
	uint8_t bConfigurationValue;
	uint8_t iConfiguration;
	uint8_t bmAttributes;
	uint8_t bMaxPower;
} usb_conf_desc_t;


#define  USB_CONFIG_ATTR_MUST_SET			(1 << 7)			//!< ɐݒ肳Ȃ΂Ȃ܂B
#define  USB_CONFIG_ATTR_BUS_POWERED		(0 << 6)			//!< ޽d
#define  USB_CONFIG_ATTR_SELF_POWERED		(1 << 6)			//!< ȋd
#define  USB_CONFIG_ATTR_REMOTE_WAKEUP		(1 << 5)			//!< uNオx

#define  USB_CONFIG_MAX_POWER(ma)			(((ma) + 1) / 2)	//!< mAł̍őd

/**
 * \brief WUSBAgLqq\
 */
typedef struct {
	uint8_t bLength;			//!< ̋Lqq޲Ăł̑傫
	uint8_t bDescriptorType;	//!< ̪Lqq^
	uint8_t bFirstInterface;	//!< ̪
	uint8_t bInterfaceCount;	//!< ֐ݒIԂ߂̒l
	uint8_t bFunctionClass;		//!< USBɂĊ蓖Ă׽
	uint8_t bFunctionSubClass;	//!< USBɂĊ蓖Ă镛׽
	uint8_t bFunctionProtocol;	//!< USBɂĊ蓖ĂK񕄍
	uint8_t iFunction;			//!< Lqq̎wW
} usb_iad_desc_t;

/**
 * \brief WUSB̪Lqq\
 */
typedef struct {
	uint8_t bLength;
	uint8_t bDescriptorType;
	uint8_t bInterfaceNumber;
	uint8_t bAlternateSetting;
	uint8_t bNumEndpoints;
	uint8_t bInterfaceClass;
	uint8_t bInterfaceSubClass;
	uint8_t bInterfaceProtocol;
	uint8_t iInterface;
} usb_iface_desc_t;

/**
 * \brief WUSB߲ċLqq\
 */
typedef struct {
	uint8_t bLength;
	uint8_t bDescriptorType;
	uint8_t bEndpointAddress;
	uint8_t bmAttributes;
	le16_t wMaxPacketSize;
	uint8_t bInterval;
} usb_ep_desc_t;


/**
 * \brief WUSBLqq\
 */
typedef struct {
	uint8_t bLength;
	uint8_t bDescriptorType;
} usb_str_desc_t;

typedef struct {
	usb_str_desc_t desc;
	le16_t string[1];
} usb_str_lgid_desc_t;

COMPILER_PACK_RESET()

//! @}

#endif /* _USB_PROTOCOL_H_ */
