/**
 * \file
 *
 * \brief SAM4L-EK
 *
 * 쌠 (C) 2012-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef BOARD_MONITOR_H_INCLUDED
#define BOARD_MONITOR_H_INCLUDED

#include "compiler.h"
#include "usart.h"
#include "board.h"
#include "sysclk.h"

//! d͊gk`
typedef enum {
	POWER_SCALING_NA		= 0,	//!< d͊gk`Ԑݒ
	POWER_SCALING_PS0		= 1,	//!< PS0d͊gk`Ԑݒ
	POWER_SCALING_PS1		= 2,	//!< PS1d͊gk`Ԑݒ
} power_scaling_t;

//! x~`
typedef enum {
	SLEEP_MODE_NA			= 0,	//!< x~p`Ԑݒ
	SLEEP_MODE_RUN			= 1,	//!< s
	SLEEP_MODE_0			= 2,	//!< x~0
	SLEEP_MODE_1			= 3,	//!< x~1
	SLEEP_MODE_2			= 4,	//!< x~2
	SLEEP_MODE_3			= 5,	//!< x~3
	SLEEP_MODE_WAIT			= 6,	//!< ҋ@
	SLEEP_MODE_RETENTION	= 7,	//!< ێ
	SLEEP_MODE_BACKUP		= 8,	//!< ޯߓ
} sleep_mode_t;

//! CPU
typedef enum {
	CPU_SRC_NA				= 0,	//!< CPUp`Ԑݒ
	CPU_SRC_RCSYS			= 1,	//!< RCSYS
	CPU_SRC_OSC0			= 2,	//!< OSC0
	CPU_SRC_PLL				= 3,	//!< PLL
	CPU_SRC_DFLL			= 4,	//!< DFLL
	CPU_SRC_RC1M			= 5,	//!< RC1M
	CPU_SRC_RC4M			= 6,	//!< RC4M
	CPU_SRC_RC80M			= 7,	//!< RC80M
	CPU_SRC_CRIPOSC			= 8,	//!< CRIPOSC
} cpu_src_t;

typedef struct
{
   power_scaling_t power_scaling;	//!< d͊gkϐ
   sleep_mode_t sleep_mode;			//!< x~ϐ
   uint32_t cpu_freq;				//!< CPUgϐ
   cpu_src_t cpu_src;				//!< CPUۯϐ
} sam4l_status_t;

typedef  struct {
	uint8_t start;
	uint8_t id;
	uint8_t dlc;
	sam4l_status_t* sam4l_status;
	uint32_t crc;
} sam4l_status_msg_t;

/**
 * \brief `Ԑݒ
 *
 */
void bm_init(void);

/**
 * \brief /֎~
 *
 * \param  state ɂtrueA֎~ɂfalse
 */
void bm_ctrl(bool state);

/**
 * \brief ϳl߲/֎~
 *
 * \param  state ɂtrueA֎~ɂfalse
 */
void bm_mouse_pointer_ctrl(bool state);

/**
 * \brief Vϳ ߲ʒu𑗏o
 *
 * \param  x xʒuA͈͂0`127
 * \param  y yʒuA͈͂0`63
 */
void bm_mouse_pointer_move(uint32_t x, uint32_t y);

/**
 * \brief LEDONɐ؂ւ
 *
 * \param  led LEDԍA͈͂0`3
 */
void bm_led_set(uint32_t led);

/**
 * \brief LEDOFFɐ؂ւ
 *
 * \param  led LEDԍA͈͂0`3
 */
void bm_led_clr(uint32_t led);

/**
 * \brief LEDON/OFFtɐ؂ւ
 *
 * \param  led LEDԍA͈͂0`3
 */
void bm_led_tgl(uint32_t led);

/**
 * \brief OLEDʂŕ\邻𓾂邽߂ɊMCUߓd𑗏o
 *
 * \param  power_scaling d͊gk
 * \param  sleep_mode    x~
 * \param  cpu_freq      CPUg
 * \param  cpu_src       CPUۯ
 */
void bm_send_mcu_status(uint32_t power_scaling, uint32_t sleep_mode,
		uint32_t cpu_freq, uint32_t cpu_src);

/**
 * \brief 肵dԂB
 *
 * \param  sleep_mode ]ދx~
 * \param  current    肵dl
 */
bool bm_get_mcu_current(uint32_t* sleep_mode, float* current);

/**
 * \brief FIFO(޲Ăł)󂫗eʂԂB
 *
 * \param  free_size ޲Ăł̋󂫗e
 */
bool bm_get_fifo_free_size(uint16_t* free_size);

/**
 * \brief PicoUARTڰёoBȓdێ邽߂500msxɐ
 *        vJn邱ƂɒӂĂB
 * \param  frame      ڰ
 * \param  timeout_ms msł̐Ԓl
 */
void bm_send_picouart_frame(uint8_t frame, uint32_t timeout_ms);

/**
 * \brief ťݐ؂ւ
 *
 * \param  timeout_ms msł̐Ԓl
 */
void bm_tgl_button(uint32_t timeout_ms);

/**
 * \brief TWIٱ߂/֎~
 *
 * \param  state ȂtrueA֎~Ȃfalse
 */
void bm_pullup_twi(bool state);

/**
 * \brief o͗̈
 *
 */
void bm_print_clear(void);

/**
 * \brief ŕ\
 *
 * \param  str        
 * \param  str_length 
 */
void bm_print_txt(uint8_t* str, uint8_t str_length);

/**
 * \brief ̧ѳŔԍ擾
 *
 * \param  fw_minor_version (ASCIIvHł)̧ѳŕԍ
 * \param  fw_major_version (ASCIIvHł)̧ѳŎԍ
 */
bool bm_get_firmware_version(uint8_t* fw_minor_version, uint8_t* fw_major_version);

#endif  // BOARD_MONITOR_H_INCLUDED
