/**
 * \file
 *
 * \brief SAMpEICײ
 *
 * 쌠 (c) 2012-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef EIC_H_INCLUDED
#define EIC_H_INCLUDED

#include "compiler.h"

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
extern "C" {
#endif
/**INDENT-ON**/
/// @endcond

/** p\EICA޲ˑ */
#if SAM4L
#define EIC_NUMBER_OF_LINES		9
#else
#error  'This device does not support EIC driver'
#endif

/** \name O荞ݐ */
/* @{ */
#define EXT_NMI		0
#define EXT_INT1	1
#define EXT_INT2	2
#define EXT_INT3	3
#define EXT_INT4	4
#define EXT_INT5	5
#define EXT_INT6	6
#define EXT_INT7	7
#define EXT_INT8	8
/* @} */

/** \name NCӑI */
/* @{ */
#define EIC_MODE_EDGE_TRIGGERED		0
#define EIC_MODE_LEVEL_TRIGGERED	1
/* @{ */

/** \name [ٔCӑI */
/* @{ */
#define EIC_EDGE_FALLING_EDGE		0
#define EIC_EDGE_RISING_EDGE		1
/* @{ */

/** \name ٔCӑI */
/* @{ */
#define EIC_LEVEL_LOW_LEVEL			0
#define EIC_LEVEL_HIGH_LEVEL		1
/* @{ */

/** \name hgCӑI */
/* @{ */
#define EIC_FILTER_ENABLED			1
#define EIC_FILTER_DISABLED			0
/* @{ */

/** \name CӑI */
/* @{ */
#define EIC_SYNCH_MODE				0
#define EIC_ASYNCH_MODE				1
/* @{ */

/** EICPʕ̌`ԐݒҰ */
struct eic_line_config {
	uint8_t eic_mode;	/**< : \ref EIC_MODE_EDGE_TRIGGERED ܂ \ref EIC_MODE_LEVEL_TRIGGERED */
	uint8_t eic_edge;	/**< [: \ref EIC_EDGE_FALLING_EDGE ܂ \ref EIC_EDGE_RISING_EDGE */
	uint8_t eic_level;	/**< : \ref EIC_LEVEL_LOW_LEVEL ܂ \ref EIC_LEVEL_HIGH_LEVEL */
	uint8_t eic_filter;	/**< hg: \ref EIC_FILTER_DISABLED ܂ \ref EIC_FILTER_ENABLED */
	uint8_t eic_async;	/**< : \ref EIC_ASYNCH_MODE or \ref EIC_SYNCH_MODE */
};

typedef void (*eic_callback_t)(void);

void eic_disable(Eic *eic);
void eic_enable(Eic *eic);

void eic_line_set_config(Eic *eic, uint8_t line_number,
	struct eic_line_config *eic_line_conf);

void eic_line_set_callback(Eic *eic, uint8_t line_number,
	eic_callback_t callback, uint8_t irq_line, uint8_t irq_level);

/**
 * \brief w肵ł̊O荞݂
 *
 * \param  eic         EICPʕ̊ڽ
 * \param  line_number ̔ԍ
 */
static inline void eic_line_enable(Eic *eic, uint8_t line_number)
{
	eic->EIC_EN = 1 << line_number;
}

/**
 * \brief w肵ł̊O荞݂֎~
 *
 * \param  eic         EICPʕ̊ڽ
 * \param  line_number ̔ԍ
 */
static inline void eic_line_disable(Eic *eic, uint8_t line_number)
{
	eic->EIC_DIS = 1 << line_number;
}

/**
 * \brief EICǂB
 *
 * \param  eic         EICPʕ̊ڽ
 * \param  line_number ̔ԍ
 *
 */
static inline bool eic_line_is_enabled(Eic *eic, uint8_t line_number)
{
	return (eic->EIC_CTRL & (1 << line_number)) != 0;
}

/**
 * \brief w肵݂̊O荞݂EIC犄荞ݐ֓`̂
 *
 * \param  eic         EICPʕ̊ڽ(EIC))
 * \param  line_number ԍ
 */
static inline void eic_line_enable_interrupt(Eic *eic,
		uint8_t line_number)
{
	eic->EIC_IER = 1 << line_number;
}

/**
 * \brief w肵݂̊O荞݂EIC犄荞ݐ֓`̂֎~
 *
 * \param  eic         EICPʕ̊ڽ(EIC))
 * \param  line_number ֎~ԍ
 */
static inline void eic_line_disable_interrupt(Eic *eic,
		uint8_t line_number)
{
	eic->EIC_IDR = 1 << line_number;
	eic->EIC_IMR;
}

/**
 * \brief EIC荞ݐĂ邩ǂB
 *
 * \param  eic         EICPʕ̊ڽ(EIC))
 * \param  line_number ԍ
 *
 * \return EIC荞ݐĂ邩ǂ
 */
static inline bool eic_line_interrupt_is_enabled(Eic *eic,
		uint8_t line_number)
{
	return (eic->EIC_IMR & (1 << line_number)) != 0;
}

/**
 * \brief w肵݂̊荞׸ނ
 * x荞݂Ȃ炱̊֐ĂłB
 *
 * \param  eic         EICPʕ̊ڽ(EIC))
 * \param  line_number ׸ނ̐ԍ
 */
static inline void eic_line_clear_interrupt(Eic *eic,
		uint8_t line_number)
{
	eic->EIC_ICR = 1 << line_number;
	eic->EIC_ISR;
}

/**
 * \brief EIC荞ݐۗǂB
 *
 * \param  eic         EICPʕ̊ڽ(EIC))
 * \param  line_number ԍ
 *
 * \return EIC荞ݐۗǂ
 */
static inline bool eic_line_interrupt_is_pending(Eic *eic,
		uint8_t line_number)
{
	return (eic->EIC_ISR & (1 << line_number)) != 0;
}

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
}
#endif
/**INDENT-ON**/
/// @endcond

/**
 * \page sam_eic_quickstart SAM EICײޗpJn̎
 *
 * ͎gpʂ̑Iײނ`Ԑݒ肵Ďgp@̒iKIȎxł
 * \ref sam_drivers_eic_group "SAM EICײ"pJ̎łB
 *
 * gʂ͏̺ޒfЂ܂݂܂B\ݒiK̺ޒfЂ͓Ǝ֐
 * ɕʂ邱ƂłAgiK͗Ⴆ΁A剞p֐ɕʂ邱Ƃł
 * ܂B
 *
 * \section eic_basic_use_case {IȎgp
 * ̊{IȎgpʂŁAEICPʕƒP͈ȉ̂悤Ɍ`Ԑݒ肳܂B
 * - ~[NƓ
 * - 荞݂ɊÂ
 * - ͂ƂEIC_LINE_5
 *
 * \subsection sam_eic_quickstart_prereq OKv
 * -# \ref sysclk_group " ۯǗ(Sysclock)"
 *
 * \section eic_basic_use_case_setup \ݒiK
 * \subsection eic_basic_use_case_setup_code ޗ
 * pÇقɒǉ܂B:
 * \code
 *   void eic_callback(void)
 *   {
 *       // EICt荞ݐۗ
 *       if (eic_line_interrupt_is_pending(EIC, GPIO_PUSH_BUTTON_EIC_LINE)) {
 *           eic_line_clear_interrupt(EIC, GPIO_PUSH_BUTTON_EIC_LINE);
 *           bToggle = 1;
 *       }
 *   }
 *   void eic_setup(void)
 *   {
 *       eic_enable(EIC);
 *
 *       eic_line_set_config(EIC, GPIO_PUSH_BUTTON_EIC_LINE, &eic_line_conf);
 *
 *       eic_line_set_callback(EIC, GPIO_PUSH_BUTTON_EIC_LINE, set_toggle_flag, EIC_5_IRQn, 1);
 *
 *       eic_line_enable(EIC, GPIO_PUSH_BUTTON_EIC_LINE);
 *   }
 * \endcode
 *
 * \subsection eic_basic_use_case_setup_flow Ƃ̗
 * -# pŊ荞݌Ăі߂֐`:
 *   - \code
*   void eic_callback(void)
 *   {
 *       // EICt荞ݐۗ
 *       if (eic_line_interrupt_is_pending(EIC, GPIO_PUSH_BUTTON_EIC_LINE)) {
 *           eic_line_clear_interrupt(EIC, GPIO_PUSH_BUTTON_EIC_LINE);
 *           bToggle = 1;
 *       }
 *   }
 * \endcode
 * -# EICPʕ:
 *   - \code eic_enable(EIC); \endcode
 *   - \note PʕۯƋx~{܂݂܂B
 * -# w肵EIC`Ԑݒ:
 *   - \code aeic_line_set_config(EIC, GPIO_PUSH_BUTTON_EIC_LINE, &eic_line_conf); \endcode
 * -# EICĂі߂֐ݒEIC荞݋
 *   - \code eic_line_set_callback(EIC, GPIO_PUSH_BUTTON_EIC_LINE, set_toggle_flag, EIC_5_IRQn, 1); \endcode
 * -# EIC:
 *   - \code eic_line_enable(EIC, GPIO_PUSH_BUTTON_EIC_LINE); \endcode
 */
#endif // EIC_H_INCLUDED
