/**
 * \file
 *
 * \brief SAM4LpFlashCALWײ
 *
 * 쌠 (c) 2012-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef FLASHCALW_H_INCLUDED
#define FLASHCALW_H_INCLUDED

#include <stddef.h>
#include <stdbool.h>
#include "compiler.h"

/* ̒`͎ͯ ̧ق̈ꕔłׂłB */
#if (!defined FLASH_PAGE_SIZE)
#   define FLASH_PAGE_SIZE     512UL
#endif
#if (!defined FLASH_NB_OF_REGIONS)
#   define FLASH_NB_OF_REGIONS 16
#endif


/* ! FLASHCALWɂĒ`ׯ̈搔 */
#define FLASHCALW_REGIONS  FLASH_NB_OF_REGIONS

/** \brief PS0FWS1ōNオ肪鎞̍ő哮g */
#define FLASH_FREQ_PS1_FWS_1_FWU_MAX_FREQ    (12000000UL)
/** \brief PS0FWS0̎̍ő哮g */
#define FLASH_FREQ_PS0_FWS_0_MAX_FREQ        (18000000UL)
/** \brief PS0FWS1̎̍ő哮g */
#define FLASH_FREQ_PS0_FWS_1_MAX_FREQ        (36000000UL)
/** \brief PS1FWS0̎̍ő哮g */
#define FLASH_FREQ_PS1_FWS_0_MAX_FREQ        (8000000UL)
/** \brief PS1FWS1̎̍ő哮g */
#define FLASH_FREQ_PS1_FWS_1_MAX_FREQ        (12000000UL)
/** \brief PS2FWS0̎̍ő哮g */
#define FLASH_FREQ_PS2_FWS_0_MAX_FREQ        (24000000UL)
/** \brief PS2FWS1̎̍ő哮g */
#define FLASH_FREQ_PS2_FWS_1_MAX_FREQ        (48000000UL)
/*! \name ׯ
 */
//! @{

uint32_t flashcalw_get_flash_size(void);

uint32_t flashcalw_get_page_count(void);

uint32_t flashcalw_get_page_count_per_region(void);

uint32_t flashcalw_get_page_region(int32_t page_number);

uint32_t flashcalw_get_region_first_page_number(uint32_t region);

//! @}


/*! \name FLASHCALW
 */
//! @{

uint32_t flashcalw_get_wait_state(void);

void flashcalw_set_wait_state(uint32_t wait_state);

void flashcalw_set_flash_waitstate_and_readmode(uint32_t cpu_f_hz,
		uint32_t ps_value, bool is_fwu_enabled);

/*! \brief flashcalw_set_flash_waitstate_and_readmode()֐̕ʖ
 *
 * \param  cpu_f_hz       CPUg
 * \param  ps_value       (ްْl)d͊gk
 * \param  is_fwu_enabled (ްْl)Nオ蓮
 */
#define flash_set_bus_freq(cpu_f_hz, ps_value, is_fwu_enabled) \
	flashcalw_set_flash_waitstate_and_readmode(cpu_f_hz, ps_value, is_fwu_enabled)

bool flashcalw_is_ready_int_enabled(void);

void flashcalw_enable_ready_int(bool enable);

bool flashcalw_is_lock_error_int_enabled(void);

void flashcalw_enable_lock_error_int(bool enable);

bool flashcalw_is_prog_error_int_enabled(void);

void flashcalw_enable_prog_error_int(bool enable);

//! @}


/*! \name FLASHCALW
 */
//! @{

bool flashcalw_is_ready(void);

void flashcalw_default_wait_until_ready(void);

extern void (*volatile flashcalw_wait_until_ready)(void);

bool flashcalw_is_lock_error(void);

bool flashcalw_is_programming_error(void);

//! @}


/*! \name FLASHCALWwߐ
 */
//! @{

uint32_t flashcalw_get_command(void);

uint32_t flashcalw_get_page_number(void);

void flashcalw_issue_command(uint32_t command, int page_number);

//! @}


/*! \name FLASHCALWS̎w
 */
//! @{

void flashcalw_no_operation(void);

void flashcalw_erase_all(void);

//! @}


/*! \name FLASHCALWی@\
 */
//! @{

bool flashcalw_is_security_bit_active(void);

void flashcalw_set_security_bit(void);

bool flashcalw_is_page_region_locked(uint32_t page_number);

bool flashcalw_is_region_locked(uint32_t region);

void flashcalw_lock_page_region(int page_number, bool lock);

void flashcalw_lock_region(uint32_t region, bool lock);

void flashcalw_lock_all_regions(bool lock);

//! @}


/*! \name ėp˭ނւ̱
 */
//! @{

bool flashcalw_read_gp_fuse_bit(uint32_t gp_fuse_bit);

uint64_t flashcalw_read_gp_fuse_bitfield(uint32_t pos, uint32_t width);

uint8_t flashcalw_read_gp_fuse_byte(uint32_t gp_fuse_byte);

uint64_t flashcalw_read_all_gp_fuses(void);

bool flashcalw_erase_gp_fuse_bit(uint32_t gp_fuse_bit, bool check);

bool flashcalw_erase_gp_fuse_bitfield(uint32_t pos, uint32_t width,
		bool check);

bool flashcalw_erase_gp_fuse_byte(uint32_t gp_fuse_byte, bool check);

bool flashcalw_erase_all_gp_fuses(bool check);

void flashcalw_write_gp_fuse_bit(uint32_t gp_fuse_bit, bool value);

void flashcalw_write_gp_fuse_bitfield(uint32_t pos, uint32_t width,
		uint64_t value);

void flashcalw_write_gp_fuse_byte(uint32_t gp_fuse_byte, uint8_t value);

void flashcalw_write_all_gp_fuses(uint64_t value);

void flashcalw_set_gp_fuse_bit(uint32_t gp_fuse_bit, bool value);

void flashcalw_set_gp_fuse_bitfield(uint32_t pos, uint32_t width,
		uint64_t value);

void flashcalw_set_gp_fuse_byte(uint32_t gp_fuse_byte, uint8_t value);

void flashcalw_set_all_gp_fuses(uint64_t value);

//! @}


/*! \name ׯ ߰ނւ̱
 */
//! @{

void flashcalw_clear_page_buffer(void);

bool flashcalw_is_page_erased(void);

bool flashcalw_quick_page_read(int page_number);

bool flashcalw_erase_page(int page_number, bool check);

bool flashcalw_erase_all_pages(bool check);

void flashcalw_write_page(int page_number);

bool flashcalw_quick_user_page_read(void);

bool flashcalw_erase_user_page(bool check);

void flashcalw_write_user_page(void);

volatile void *flashcalw_memset8(volatile void *dst, uint8_t src,
		size_t nbytes, bool erase);

volatile void *flashcalw_memset16(volatile void *dst, uint16_t src,
		size_t nbytes, bool erase);

volatile void *flashcalw_memset32(volatile void *dst, uint32_t src,
		size_t nbytes, bool erase);

volatile void *flashcalw_memset64(volatile void *dst, uint64_t src,
		size_t nbytes, bool erase);

/*! \brief JԂ\a src ޯ޴ިݗl\a dst ɂĎwׯ
 *         ]\a nbytes ޲Ă𕡎
 *
 * SĂ߲Ƒ傫񂪎x܂B
 *
 * \param  dst       ׯ]ւ̈ʒuwq(߲)
 * \param  src       {
 * \param  src_width ޯĂł\a src : 8,16,32,܂64
 * \param  nbytes    ݒ肷޲Đ
 * \param  erase     Oɏ邩ǂ: \c true ܂ \c false
 *
 * \return \a dst ̒l
 *
 * \warning ̊֐͓]悪ꂽꂾŐꍇɂ\c false ɐݒ肳
 *          ꂽ\a erase ŌĂ΂邩ꂸAÅ֐͈ȑOɏꂽ
 *          1ޯĂɂ̂Ɏgp邱Ƃ͂ł܂BႦ΁A
 *          \c 0x00000001Ǎ\c 0xFFFFFFFE ꂽꍇAׯ̌ʒl
 *          \c 0x00000000 ƈႤ܂B
 *
 * \warning w߂{ꂽ̈܂۰ޕیɑ߰ނɎw߂Kp
 *          ꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
#define flashcalw_memset(dst, src, src_width, nbytes, erase) \
	TPASTE2(flashcalw_memset, src_width) ((dst), (src), (nbytes), (erase))

volatile void *flashcalw_memcpy(volatile void *dst, const void *src,
		size_t nbytes, bool erase);

//! @}

/*! \name PicoCache̪
 */
//! @{

void flashcalw_picocache_enable(void);

void flashcalw_picocache_disable(void);

uint32_t flashcalw_picocache_get_status(void);

void flashcalw_picocache_invalid_all(void);

void flashcalw_picocache_invalid_line(uint32_t index);

void flashcalw_picocache_set_monitor_mode(uint32_t mode);

void flashcalw_picocache_enable_monitor(void);

void flashcalw_picocache_disable_monitor(void);

void flashcalw_picocache_reset_monitor( void );

uint32_t flashcalw_picocache_get_monitor_cnt( void );

uint32_t flashcalw_picocache_get_version( void );

//! @}

/**
 * \page sam_flashcalw_quickstart SAM FLASHCALWײޗpJn̎
 *
 * ͎gpʂ̑Iײނ`Ԑݒ肵Ďgp@̒iKIȎwł
 * \ref group_sam_drivers_flashcalw "SAM FLASHCALWײ"pJn̎
 * B
 *
 * gpʂ͏̺ޒfЂ܂݂܂B\ݒiK̺ޒfЂ͓Ǝ֐
 * ʂ邱ƂłAgiK͗Ⴆ΁A剞p֐ɕʂ邱Ƃł
 * B
 *
 * \section flashcalw_basic_use_case {IȎgp
 * ̊{IȎgpʂŁAŌ߰ނƎgp߰ނ͓ʂȊpIԍŏ
 * B
 *
 * \subsection sam_flashcalw_quickstart_prereq OKv
 * -# \ref sysclk_group " ۯǗ(Sysclock)"
 *
 * \section flashcalw_basic_use_case_setup \ݒiK
 * \note CLK_FLASHCALW_AHBCLK_FLASHCALW_APB͊ɂċ܂B
 * \subsection flashcalw_basic_use_case_setup_code ޗ
 * conf_clock.hňȉϸۂ܂B:
 * \code
 *  #define CONFIG_SYSCLK_SOURCE   SYSCLK_SRC_RCFAST
 *  #define CONFIG_RCFAST_FRANGE    2
 * \endcode
 *
 * pÇقɈȉ̺ނǉ܂B:
 * \code
 *  sysclk_init();
 * \endcode
 *
 * \subsection flashcalw_basic_use_case_setup_flow Ƃ̗
 * -#  ۯƂčRCUݒ肵܂B:
 *   - \code #define CONFIG_SYSCLK_SOURCE SYSCLK_SRC_RCFAST \endcode
 * -# 12MHzƂčRCUݒ肵܂B:
 *   - \code #define CONFIG_RCFAST_FRANGE    2 \endcode
 * -#  ۯ܂B
 *   - \code sysclk_init(); \endcode
 *
 * \section flashcalw_basic_use_case_usage giK
 * \subsection flashcalw_basic_use_case_usage_code ޗ
 * pÇقŗႦmainJԂɒǉ܂B:
 * \code
 *    #define MAGIC_NUM 0x4c4d5441
 *    #define PAGE_ADDRESS (FLASH_ADDR + FLASH_SIZE - FLASH_PAGE_SIZE)
 *    #define USER_PAGE_ADDRESS (FLASH_USER_PAGE_ADDR + 8)
 *    static const uint32_t write_data = MAGIC_NUM;
 *
 *    flashcalw_memcpy((void *)PAGE_ADDRESS, &write_data, 4, true);
 *    flashcalw_memcpy((void *)USER_PAGE_ADDRESS, &write_data, 4, true);
 * \endcode
 *
 * \subsection flashcalw_basic_use_case_usage_flow Ƃ̗
 * -# ʒuƊpIԍ`܂B:
 *   - \code #define MAGIC_NUM 0x4c4d5441 \endcode
 *   - \code #define PAGE_ADDRESS (FLASH_ADDR + FLASH_SIZE - FLASH_PAGE_SIZE)
 * \endcode
 *   - \code USER_PAGE_ADDRESS (FLASH_USER_PAGE_ADDR + 8) \endcode
 *   - \note gp߰̍ŏ2ꂪ\񂳂Ă邽߁ALʒu͎gp߰ނ
 *           n߂łĂ͂Ȃ܂B
 *   - \code static const uint32_t write_data = MAGIC_NUM; \endcode
 * -# pIԍׯz֏܂B:
 *   - \code flashcalw_memcpy((void *)PAGE_ADDRESS, &write_data, 4, true); \endcode
 * -# pIԍgp߰ނ֏܂B:
 *   - \code flashcalw_memcpy((void *)USER_PAGE_ADDRESS, &write_data, 4, true);
 * \endcode
 *
 */
#endif  /* FLASHCALW_H_INCLUDED */
