/**
 * \file
 *
 * \brief GPIOײ
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef GPIO_H_INCLUDED
#define GPIO_H_INCLUDED

#include "compiler.h"
#include "ioport.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \defgroup group_sam_drivers_gpio GPIO - ėpo
 *
 * ߏGPIO̍xGPIO@\pײނłB:
 * 荞݂Ǝۂx
 *
 * \section dependencies ˑ
 *
 * GPIOPʕ͈ȉ̒PʕɈˑ܂B:
 * - ۯp\ref sysclk_group
 * - 荞݂܂͋֎~邽ڂ\ref interrupt_group
 * - {IGPIO@\p\ref ioport_group
 * @{
 */

/**
 * \brief GPIOݗp̊荞݌Ăі߂֐^
 *
 * 荞ݏ͊֐Ăі߂s悤Ɍ`Ԑݒ肳AĂі߂֐
 * gpio_pin_callback_t^ɍvȂ΂Ȃ܂B
 *
 */
typedef void (*gpio_pin_callback_t)(void);

/**
 * \name 荞ݎx
 *
 * GPIOGPIO݂ł̕ωoɊ荞݂𐶐悤Ɍ`Ԑݒ肷邱
 * ł܂B
 *
 * @{
 */

bool gpio_set_pin_callback(ioport_pin_t pin, gpio_pin_callback_t callback,
		uint8_t irq_level);

/**
 * \brief ݂̊荞݂
 *
 * \param  pin ݔԍ
 */
static inline void gpio_enable_pin_interrupt(ioport_pin_t pin)
{
	GpioPort *gpio_port = &(GPIO->GPIO_PORT[ioport_pin_to_port_id(pin)]);
	gpio_port->GPIO_IERS = ioport_pin_to_mask(pin);
}

/**
 * \brief ݂̊荞݂֎~
 *
 * \param  pin ݔԍ
 */
static inline void gpio_disable_pin_interrupt(ioport_pin_t pin)
{
	GpioPort *gpio_port = &(GPIO->GPIO_PORT[ioport_pin_to_port_id(pin)]);
	gpio_port->GPIO_IERC = ioport_pin_to_mask(pin);
}

/**
 * \brief ݂̊荞׸ނ擾
 *
 * \param  pin ݔԍ
 *
 * \return ݊荞׸(0/1)
 */
static inline uint32_t gpio_get_pin_interrupt_flag(ioport_pin_t pin)
{
	GpioPort *gpio_port = &(GPIO->GPIO_PORT[ioport_pin_to_port_id(pin)]);
	return (((gpio_port->GPIO_IFR && ioport_pin_to_mask(pin)) == 0) ? 0 : 1);
}

/**
 * \brief ݂̊荞׸ނ
 *
 * \param  pin ݔԍ
 */
static inline void gpio_clear_pin_interrupt_flag(ioport_pin_t pin)
{
	GpioPort *gpio_port = &(GPIO->GPIO_PORT[ioport_pin_to_port_id(pin)]);
	gpio_port->GPIO_IFRC = ioport_pin_to_mask(pin);
}

/** @} */

/**
 * \name Ӌ@\ۼюx
 *
 * GPIOݒlωA܂͏㏸[≺~[oꂽ̂悤Ȋ荞ݏ
 * oꂽɕKӋ@\ۂo͂悤ɐݒ肷邱Ƃł܂B
 *
 * @{
 */

/**
 * \brief ݂̎Ӌ@\ې
 *
 * \param  pin ݔԍ
 */
static inline void gpio_enable_pin_periph_event(ioport_pin_t pin)
{
	GpioPort *gpio_port = &(GPIO->GPIO_PORT[ioport_pin_to_port_id(pin)]);
	gpio_port->GPIO_EVERS = ioport_pin_to_mask(pin);
}

/**
 * \brief ݂̎Ӌ@\ې֎~
 *
 * \param  pin ݔԍ
 *
 */
static inline void gpio_disable_pin_periph_event(ioport_pin_t pin)
{
	GpioPort *gpio_port = &(GPIO->GPIO_PORT[ioport_pin_to_port_id(pin)]);
	gpio_port->GPIO_EVERC = ioport_pin_to_mask(pin);
}

/** @} */

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

/**
 * \page sam_gpio_quick_start GPIOײނ̑Jn̎
 *
 * ͓̎gpʂɑ΂ײނ`Ԑݒ肵Ďgp@̒iKIȎx
 * \ref group_sam_drivers_gpio p̑Jn̎łB
 *
 * gpʂ͏̺ޒfЂ܂݂܂B\ݒiK̺ޒfЂ͓Ǝ֐
 * ʂ邱ƂłAgiK͗ႦΎ剞p֐ɕʂ邱Ƃł
 * B
 *
 * \section gpio_qs_use_cases g
 * - \ref gpio_int
 *
 * \section gpio_int GPIO荞݂̎g
 *
 * ̎gpʂSAM4L-EKŊ荞݂N邽߂(PC03)݂`Ԑݒ肷
 * @܂B
 *
 * \section gpio_int_setup \ݒiK
 *
 * \subsection gpio_int_prereq OKv
 *
 * ̒Pʕ͈ȉ̻޽KvłB
 * - \ref clk_group
 * - \ref ioport_group
 *
 * \subsection gpio_int_setup_code \ݒ躰ޗ
 *
 * mainJԂ܂͏֐ɒǉ܂B:
 * \code
 *   ioport_set_pin_dir(PIN_PC03, IOPORT_DIR_INPUT);
 *   ioport_set_pin_mode(PIN_PC03, IOPORT_MODE_PULLUP |
 *       IOPORT_MODE_GLITCH_FILTER);
 *   ioport_set_pin_sense_mode(PIN_PC03, IOPORT_SENSE_FALLING);
 *   if (!gpio_set_pin_callback(PIN_PC03, pb0_callback, 1)) {
 *       printf("Set pin callback failure!\r\n");
 *       while (1) {
 *       }
 *   }
 *   gpio_enable_pin_interrupt(PIN_PC03);
 * \endcode
 *
 * \subsection gpio_setup_workflow {Iȍ\ݒƂ̗
 *
 * -# 荞݂N悤݂BłPCO3ٱ߂ƕshg
 *    ͂Ƃ݂̉~[̎Ɋ荞݂𐶐悤ɏ܂B
 *  \code
 *   ioport_set_pin_dir(PIN_PC03, IOPORT_DIR_INPUT);
 *   ioport_set_pin_mode(PIN_PC03, IOPORT_MODE_PULLUP |
 *       IOPORT_MODE_GLITCH_FILTER);
 *   ioport_set_pin_sense_mode(PIN_PC03, IOPORT_SENSE_FALLING);
 *  \endcode
 * -# ݊荞ݗpĂі߂ݒ肵܂B
 *  \code
 *   if (!gpio_set_pin_callback(PIN_PC03, pb0_callback, 1)) {
 *       printf("Set pin callback failure!\r\n");
 *       while (1) {
 *       }
 *   }
 *  \endcode
 * -# 荞݂܂B
 *  \code gpio_enable_pin_interrupt(PIN_PC03); \endcode
 *
 * \section gpio_int_usage 荞݂̎g
 *
 * ݂Ŋ荞ݔAȂ̌Ăі߂֐s܂B
 * \code
 *  static void pb0_callback(void)
 *  {
 *      // ݊荞ݏ
 *  }
 * \endcode
 *
 */
#endif  /* GPIO_H_INCLUDED */
