/**
 * \file
 *
 * \brief DALIMޯĂ̕ƕ
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include <string.h>
#include "dali_top.h"

/* USARTDLAÎ߂ޯĕψ */
#define USART_RX_SAMPLE_BITS_OFFSET		2

volatile bool edma_rx_flag = false;

void dali_usart_init_rs232(USART_t *usart);
void dali_usart_set_rs232_tx(USART_t *usart);
void usart_set_sync_baudrate(USART_t *usart, uint32_t baud, uint32_t cpu_hz);
void dali_usart_set_xcl_tx(void);
void dali_usart_set_edma_rx(void);
uint8_t dali_decode_from_uart_byte(uint8_t *input_buf, uint8_t *output_buf, uint8_t max_input_num);
void convert_dali_data_to_usart(uint8_t *dail_buf, uint8_t *usart_buf, uint8_t count);

/* USARTCӑI */
static dali_usart_rs232_options_t USART_SERIAL_OPTIONS = {
	.rx_async_baudrate = USART_SERIAL_RX_ASYNC_BAUDRATE,
	.tx_sync_baudrate = USART_SERIAL_TX_SYNC_BAUDRATE,
	.charlength = USART_SERIAL_CHAR_LENGTH,
	.paritytype = USART_SERIAL_PARITY,
	.stopbits = USART_SERIAL_STOP_BIT,
	.start_frame_detection = false,
	.one_wire = false,
	.rx_pec_length = USART_SERIAL_RX_VARIABLE_CHAR_LENGTH,
	.tx_pec_length = USART_SERIAL_TX_VARIABLE_CHAR_LENGTH,
	.pec_action = USART_PECACT_PERC01_gc,
	.encoding_type = USART_DECTYPE_NOTSDATA_gc,
	.encoding_stream = USART_LUTACT_TX_gc,
};

void dali_bit_init(void)
{
	dali_usart_init_rs232(USART_SERIAL);
	/* dON̎MԂݒ */
	dali_usart_set_rs232_rx(USART_SERIAL);
	dali_usart_set_edma_rx();
}

/**
 *  \brief MƎM̗ɂĎgpUSARTݒ
 *
 *  \param  usart USARTPʕւ̈ʒuwq
 */
void dali_usart_init_rs232(USART_t *usart)
{
	sysclk_enable_peripheral_clock(usart);
	usart_format_set(usart, USART_SERIAL_OPTIONS.charlength, USART_SERIAL_OPTIONS.paritytype,
			USART_SERIAL_OPTIONS.stopbits);

	/* KvƂȂA/`Ԑݒ */
	if (USART_SERIAL_OPTIONS.encoding_stream != USART_LUTACT_OFF_gc) {
		usart_xmegae_encoding(usart, USART_SERIAL_OPTIONS.encoding_type,
				USART_SERIAL_OPTIONS.encoding_stream);
	}

	usart_sfden(usart, USART_SERIAL_OPTIONS.start_frame_detection);
	usart_onewire(usart, USART_SERIAL_OPTIONS.one_wire);

	/* USART PEC>0̂߁AXCL PECgpׂŁA`Ԑݒ */
	xcl_enable(XCL_SYNCHRONOUS);
	xcl_port(USART_SERIAL_XCL_PORT);
	xcl_tc_type(PEC01);
	usart_xmegae_pec_action(usart, USART_SERIAL_OPTIONS.pec_action);
}

bool dali_usart_set_rs232_rx(USART_t *usart)
{
	bool result;

	xcl_pec_set_lenght(USART_SERIAL_OPTIONS.rx_pec_length - 1);
	usart_set_mode(usart, USART_CMODE_ASYNCHRONOUS_gc);
	result = usart_set_baudrate(usart, USART_SERIAL_OPTIONS.rx_async_baudrate, sysclk_get_per_hz());
	return result;
}

/**
 * \brief USART𑗐MԂɐݒ
 *
 * ̊֐USART𓯊ɐݒ肵܂B
 *
 * \param  usart USARTPʕւ̈ʒuwq
 */
void dali_usart_set_rs232_tx(USART_t *usart)
{
	xcl_pec_set_lenght(USART_SERIAL_OPTIONS.tx_pec_length - 1);
	usart_set_mode(usart, USART_CMODE_SYNCHRONOUS_gc);
	usart_set_sync_baudrate(usart, USART_SERIAL_OPTIONS.tx_sync_baudrate, sysclk_get_per_hz());
	usart_tx_enable(usart);
}

/**
 * \brief USARTPʕœްڰĒlݒ
 *
 * ̊֐CPUgɊւړxްڰ ڼ޽ݒ肵܂B̊֐͂
 * gŐݒvZȂA܂͑sްڰĂ̕ύXKvƂꍇ
 * gp邱Ƃł܂B
 *
 * \param  usart  USARTPʕ
 * \param  baud   ްڰ
 * \param  cpu_hz CPUg
 */
void usart_set_sync_baudrate(USART_t *usart, uint32_t baud, uint32_t cpu_hz)
{
	int8_t exp;
	uint32_t div;
	uint32_t limit;
	uint32_t ratio;

	/* EwT܂B */
	limit = 0x1FFFU;
	ratio = cpu_hz / baud;

	for (exp = 0; exp < 7; exp++) {
		if (ratio < limit) {
			break;
		}
		limit <<= 1;
	}
	div = ((cpu_hz/baud) >> (1+exp)) - 1;
	usart->BAUDCTRLB = (uint8_t)(((div >> 8) & 0x0F) | (exp << 4));
	usart->BAUDCTRLA = (uint8_t)div;
}

/**
 * \brief USARTMŎgpXCLԂݒ
 *
 * XCL͂ƂUSARTMƸۯADALIMƂĂXNOR XCLo
 *
 */
void dali_usart_set_xcl_tx(void)
{
	xcl_lut_type(LUT_2LUT2IN);
	xcl_lut_in2(USART_SERIAL_LUT_IN_PIN);
	xcl_lut_in3(LUT_IN_XCL);
	xcl_lut1_truth(XOR);
}

/**
 * \brief DALI޲č\D7,D7,`,D0UART\D0,D1,`,D7ɕϊ
 */
void convert_dali_data_to_usart(uint8_t *dail_buf, uint8_t *usart_buf, uint8_t count)
{
	uint8_t i,j;
	for(i = 0; i < count; i++) {
		usart_buf[i] = 0; 
		for (j = 0; j < 7; j++)	{
			if (dail_buf[i] & 0x01) {
				usart_buf[i] |= 0x01;
			}
			dail_buf[i] >>= 1;
			usart_buf[i] <<= 1;
		}
		if (dail_buf[i] & 0x01) {
			usart_buf[i] |= 0x01;
		}
	}
}

void dali_bits_tx(void)
{
	uint8_t send_data[2], dali_data[2];

	if (master_info.dali_send_status == SENDING_START) {
		dali_usart_set_rs232_tx(USART_SERIAL);
		dali_usart_set_xcl_tx();

		dali_data[0] = master_info.usart_rx_buf[0];
		dali_data[1] = master_info.usart_rx_buf[1];
		convert_dali_data_to_usart(dali_data, send_data, 2);
		
		usart_putchar(USART_SERIAL, send_data[0]);
		usart_putchar(USART_SERIAL, send_data[1]);
		master_info.dali_send_status = SENDING_ONGOING;
	} else if (master_info.dali_send_status == SENDING_ONGOING) {
		if (usart_tx_is_complete(USART_SERIAL)) {
			usart_clear_tx_complete(USART_SERIAL);
			master_info.dali_send_status = SENDING_STOP;
		}
	}
}

void dali_bits_rx(void)
{
	/* EDMAقUSARTMԂ𒲍 */
	if (edma_rx_flag == true){
		edma_rx_flag = false;
		master_info.dali_rx_byte[0]=0;
		master_info.dali_rx_byte[1]=0;
		master_info.dali_rx_flag = dali_decode_from_uart_byte(destination, master_info.dali_rx_byte, EDMA_DEST_BUFFER_SIZE);
	}
}

static void dali_edma_rx_transfer_done(edma_channel_status_t status)
{
	/* M֎~ */
	usart_rx_disable(USART_SERIAL);
	edma_rx_flag = true;
}

/**
 *  \brief USARTްDALI޲Ă𕜍
 *
 * KiQƁADALIڰэ\STARTADDRESS-DATASTOPłBDALIɂāA2
 * "0"HighLowA"1"LowHighłB2قUSART_SERIAL_RX_SAMPLE_BITS
 * ƂĒ`ꂽ6{USARTޯĂɂč̎悳܂B
 *
 * \param  input_buf     USARTMް̊ɏՕ
 * \param  output_buf    DALI޲Ă̊ɏՕ
 * \param  max_input_num ɕKvȍőUSARTް
 *
 * \retval RX_ONE_BYTE:  1޲ĕ
 *         RX_TWO_BYTES: 2޲ĕ
 *         RX_FAILUER:   s
 */
uint8_t dali_decode_from_uart_byte(uint8_t *input_buf, uint8_t *output_buf, uint8_t max_input_num)
{
	uint8_t ret = RX_FAILUER;
	uint8_t i, j, usart_bit_value, usart_bit_num;
	uint8_t dali_bit_is_0 = 0x01, dali_bit_is_1 = 0x02, dali_half_bit_num = 0, dali_bit_num = 0, dali_bits = 0;

	usart_bit_value = input_buf[0] & 0x01;
	/* lUSARTJnޯĂӖ1łB */
	usart_bit_num = 1;
	for (i = 0; i < max_input_num; i++)	{
		/* 1USARTް8ޯĂ̌JԂ */
		for (j = 0; j < 8; j++) {
			if ((input_buf[i] & 0x01) == usart_bit_value) {
				usart_bit_num++;
			} else { /* DALIMٔ] */
				if((usart_bit_num >= (USART_SERIAL_RX_SAMPLE_BITS - USART_RX_SAMPLE_BITS_OFFSET)) &&
						(usart_bit_num <= (USART_SERIAL_RX_SAMPLE_BITS + USART_RX_SAMPLE_BITS_OFFSET))) {
					dali_bits += (usart_bit_value << dali_half_bit_num);
					dali_half_bit_num++;	
				} else if ((usart_bit_num >= (2 * (USART_SERIAL_RX_SAMPLE_BITS - USART_RX_SAMPLE_BITS_OFFSET))) &&
						(usart_bit_num <= (2  * (USART_SERIAL_RX_SAMPLE_BITS + USART_RX_SAMPLE_BITS_OFFSET)))) {
					dali_bits += (usart_bit_value << dali_half_bit_num) + (usart_bit_value << (dali_half_bit_num + 1));
					dali_half_bit_num += 2;
				} else {
					/* Ԉُ */
					return ret;
				}
				usart_bit_value ^= 0x01;
				usart_bit_num = 1;

				/* DALIޯĕ */
				if (dali_half_bit_num >= 2) {
					/* ޯĂ0 */
					if ((dali_bits & 0x03) == dali_bit_is_0) {
						if (dali_bit_num == 0) {
							/* JnޯĂ1łׂ */
							return ret;
						} else if (dali_bit_num <= 8) {
							/* 1`8ޯĂDALI1޲ */	
							output_buf[0] <<= 1;
						} else if (dali_bit_num <= 16) {
							/* 9`16ޯĂDALI2޲ */
							output_buf[1] <<= 1;
						} else {
							return ret;
						}
					} else if ((dali_bits & 0x03) == dali_bit_is_1) {
					/* ޯĂ1 */						
						if (dali_bit_num == 0) {
						/* 擪ޯ1DALIJnޯ */	
						} else if (dali_bit_num <= 8) {
							/* 1`8ޯĂDALI1ޯ */	
							output_buf[0] = (output_buf[0] << 1) + 1;
						} else if (dali_bit_num <= 16) {
							/* 9`16ޯĂDALI2޲ */
							output_buf[1] = (output_buf[1] << 1) + 1;
						} else {
							return ret;
						}
					} else {
						/* 2 */
						return ret;
					}
					dali_half_bit_num -= 2;
					dali_bit_num ++;
					dali_bits >>= 2;
				}
			} // if ((input_buf[i] & 0x01) == usart_bit_value)
			input_buf[i] >>= 1;
		}
		/* ق͒~ޯ */
		if (usart_bit_num >= (4 * (USART_SERIAL_RX_SAMPLE_BITS - USART_RX_SAMPLE_BITS_OFFSET)))
		{
			if(usart_bit_value == 0x01) {
				if (dali_bit_num == 8) {
					/* ŏIޯĂ1 */
					output_buf[0] = (output_buf[0] << 1) + 1;
					return RX_ONE_BYTE;
				} else if (dali_bit_num == 9) {
					/* ŏIޯĂ0 */
					return RX_ONE_BYTE;
				} else if (dali_bit_num == 16) {
					/* ŏIޯĂ1 */
					output_buf[1] = (output_buf[1] << 1) + 1;
					return RX_TWO_BYTES;
				} else if (dali_bit_num == 17) {
					/* ŏIޯĂ0 */
					return RX_TWO_BYTES;
				} else {
					/* sޯĔԍDALIڰ */
					return ret;
				}
			} else {
				/* Low0ُ */
				return ret;
			}
		}
	} // for (i = 0; i < max_input_num; i++)
	/* s */
	return ret;
}

/**
 * \brief USARTMڼ޽ɐڑEDMAقݒ
 */
void dali_usart_set_edma_rx(void)
{
	struct edma_channel_config usart_rx_conf;

	edma_enable(EDMA_CHMODE);
	edma_set_priority_mode(EDMA_PRIMODE);
	/*
	 * ǂ̂͂ޯĂȂ悤Ɍ`Ԑݒ肪SĂ0ݒ肷邱Ƃm܂B
	 */
	memset(&usart_rx_conf, 0, sizeof(usart_rx_conf));
	/*
	 * ̺ނ͈ȉ̐ݒEDMA_RX_CHANNELق`Ԑݒ肵܂B
	 * (Q: 'usart_rx_conf'`Ԑݒ\)
	 */
	edma_channel_set_burst_length(&usart_rx_conf, EDMA_CH_BURSTLEN_1BYTE_gc);
	edma_channel_set_transfer_count8(&usart_rx_conf, EDMA_DEST_BUFFER_SIZE);
	edma_channel_set_memory_reload_mode(&usart_rx_conf,
			EDMA_CH_RELOAD_TRANSACTION_gc);
	edma_channel_set_memory_dir_mode(&usart_rx_conf, EDMA_CH_DIR_INC_gc);
	edma_channel_set_memory_address(&usart_rx_conf,
			(uint16_t)(uintptr_t)destination);
	edma_channel_set_trigger_source(&usart_rx_conf,
			EDMA_CH_TRIGSRC_USARTD0_RXC_gc);
	edma_channel_set_single_shot(&usart_rx_conf);
	edma_channel_set_interrupt_level(&usart_rx_conf, EDMA_INT_LVL_LO);
	edma_channel_write_config(EDMA_RX_CHANNEL, &usart_rx_conf);
	edma_set_callback(EDMA_RX_CHANNEL, dali_edma_rx_transfer_done);
}
